VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Risoluzione MAC"
   ClientHeight    =   2100
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3645
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2100
   ScaleWidth      =   3645
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   840
      MaxLength       =   16
      TabIndex        =   1
      Top             =   360
      Width           =   2415
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Risolvi MAC"
      Default         =   -1  'True
      Height          =   375
      Left            =   840
      TabIndex        =   0
      Top             =   1560
      Width           =   2055
   End
   Begin VB.Label Label2 
      Caption         =   "MAC"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   615
   End
   Begin VB.Label LblMAC 
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   840
      TabIndex        =   3
      Top             =   840
      Width           =   2415
   End
   Begin VB.Label Label1 
      Caption         =   "Host:"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   360
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'****************************************************************
'* restituisce il MAC di NomeHost in LAN o -1 in caso di errore *
'* FUNZIONA SU MACCHINE CHE HANNO SOLO UN'INTERFACCIA DI RETE   *
'* NECESSARIA ABILITAZIONE NetBIOS e Client Per Reti M. per W9x *
'****************************************************************

Public Function DaiMACAddress(ByVal NomeHost As String) As String
    On Error Resume Next
    Dim Tmp As String, pASTAT As Long
    Dim NCB As NET_CONTROL_BLOCK, AST As ASTAT
    Dim NomeGiusto As Boolean
    
    NCB.ncb_command = NCBRESET   'resetta la mia Interfaccia
    Call Netbios(NCB)
    
    'La lunghezza massima del Nome host  16 caratteri
    
    NCB.ncb_callname = NomeHost  'setta l'host remoto di cui si vuol
    NCB.ncb_command = NCBASTAT   'conoscere il MAC e richiede le info
    
    
    NCB.ncb_lana_num = 0         'forza la lettura dei dati sull'interfaccia 0
    NCB.ncb_length = Len(AST)    'ALTRIMENTI SE SI HANNO + INTERFACCE BISOGNA
                                 'LEGGERE SU OGNUNA
    
    'gestisce l'Heap per l'allocazione dinamica della struttura NET_CONTROL_BLOCK
    
    pASTAT = HeapAlloc(GetProcessHeap(), HEAP_GENERATE_EXCEPTIONS Or HEAP_ZERO_MEMORY, NCB.ncb_length)
    
    'controllo sul puntatore pASTAT
    
    If pASTAT = 0 Then
        Debug.Print "Errore nell'allocazione della Memoria"
        Exit Function
    End If
    
    'riempie i Dati nella struttura ASTAT
    
    NCB.ncb_buffer = pASTAT
    Call Netbios(NCB)
    
    CopyMemory AST, NCB.ncb_buffer, Len(AST)
    
    'controlla i dati ritornati e che hanno riempito la struttura ASTAT
    
    NomeGiusto = False
    For t = 0 To 5
        If AST.adapt.adapter_address(t) <> 0 Then
            NomeGiusto = True
            Exit For
        End If
    Next
    
    'se l'hosto non  raggiungibile ritorna 0 in tutto l'array e NomeGiusto  false
    
    If NomeGiusto = True Then
        Tmp = Format$(Hex(AST.adapt.adapter_address(0)), "00") & "-" & Format$(Hex(AST.adapt.adapter_address(1)), "00") & "-" & Format$(Hex(AST.adapt.adapter_address(2)), "00") & "-" & Format$(Hex(AST.adapt.adapter_address(3)), "00") & "-" & Format$(Hex(AST.adapt.adapter_address(4)), "00") & "-" & Format$(Hex(AST.adapt.adapter_address(5)), "00")
        HeapFree GetProcessHeap(), 0, pASTAT
        DaiMACAddress = Tmp
    Else
        DaiMACAddress = "-1"
    End If
End Function

'***************** ESEMPIO DI APPLICAZIONE ********************

Private Sub Command1_Click()
    Screen.MousePointer = vbHourglass
    x = DaiMACAddress(UCase(Text1.Text))
    If x = "-1" Then x = "Host Inesistente"
    LblMAC = x
    LblMAC.Refresh
    Screen.MousePointer = vbNormal
End Sub
